/*
  The MIT License (MIT)

  Copyright (c) 2018 J. Eric Townsend

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.
*/

var serial;
var portName = '/dev/cu.usbmodem1421';
var dataRead;
var dataWrite;

var blueLedVal;
var redLedVal;

var sleepcircle = 150; 
var bathroomcircle = 400;
var moviecircle = 650;

var ycircle = 400; 
var h = 200; 

var xClick = 0;
var yClick = 0;

var i = 0; 


function setup()
{
    serial = new p5.SerialPort(); 
    // now set a number of callback functions for SerialPort
    serial.on('list', printList); 
    serial.on('connected', serverConnected);
    serial.on('open', portOpen); 
    serial.on('data', serialEvent);
    serial.on('error', serialError);
    serial.on('close', portClose); 
    serial.list();
    serial.open(portName);

    // set up our drawing environment
    createCanvas(800, 800);
}

function draw()
{
    background(0); // set the background to black
     // fill with white
    var ho = hour();
    var m = minute();
    textFont('Georgia');
    textSize(32);
    text('Current time:' + ' ' +  ho + ':' +  m, 10, 50);

//According to a survey conducted by Travelodge, participants who slept in a blue room got the best night's sleep

    textFont('Georgia');
    fill(87, 164, 255);
    ellipse(sleepcircle, ycircle, h, h);
    fill('White');
    textSize(32);
    text('SLEEP', 100, 400);

    fill(255,80,170);
    ellipse(bathroomcircle, ycircle, h, h);

    fill('White');
    textSize(32);
    text('BATHROOM', 305, 400);

    fill(187,158,232);
    ellipse(moviecircle, ycircle, h, h);

    fill('White');
    textSize(32);
    text('MOVIE', 600, 400);

}


function mouseClicked()
{
    xClick = mouseX;

    yClick = mouseY;



    if ((xClick > sleepcircle-95) && (xClick < sleepcircle+95)
        && (yClick < ycircle + 95) && (yClick > ycircle - 95)) {
		    setTimeout(sendSleep, 8000);
}

    else if ((xClick > bathroomcircle-95) && (xClick < bathroomcircle+95)
        && (yClick < ycircle + 95) && (yClick > ycircle - 95)) {
    	sendBathroom(); 
    	setTimeout(stopBathroom, 2000);
    } 

     else if ((xClick > moviecircle-95) && (xClick < moviecircle+95)
        && (yClick < ycircle + 95) && (yClick > ycircle - 95)) {
     	sendMovie(); 
     	setTimeout(stopMovie, 5000);
    } 
    else {
      	print("No circle") 
    }
 }


function sendSleep()
{
serial.write('S');
print ("Sleep")
}

function sendBathroom()
{
serial.write('B');
print ("Bathroom")
}

function sendMovie()
{
serial.write('M');
print ("Movie")
}

function stopBathroom()
{
serial.write('X');
print("Stop Bathroom")
}

function stopMovie()
{
serial.write('Y');
print("Stop Movie")
}

function printList(portList) {
    // for (var i = 0; i < portList.length; i++) {
    //     print(i + " " + portList[i]);
    // }
}

function serverConnected()
{
    print('serverConnected');
}

function portOpen()
{
    print('portOpen');
}

function serialEvent()
{
}

function serialError(err)
{
    print('serialError ' + err);
}

function portClose()
{
    print('portClose');
}
